import { registerV2 as publicRegisterV2, loginV2 as publicLoginV2, changePassword as publicChangePassword, loginCallback as publicLoginCallback, signOn as publicSignOn, logout as publicLogout, verify as publicVerify } from './iam-authentication-v1-authentication-authentication.public.js';
import { BuildRESTFunction, MaybeContext } from '@wix/sdk-types';
export declare const registerV2: MaybeContext<BuildRESTFunction<typeof publicRegisterV2> & typeof publicRegisterV2>;
export declare const loginV2: MaybeContext<BuildRESTFunction<typeof publicLoginV2> & typeof publicLoginV2>;
export declare const changePassword: MaybeContext<BuildRESTFunction<typeof publicChangePassword> & typeof publicChangePassword>;
export declare const loginCallback: MaybeContext<BuildRESTFunction<typeof publicLoginCallback> & typeof publicLoginCallback>;
export declare const signOn: MaybeContext<BuildRESTFunction<typeof publicSignOn> & typeof publicSignOn>;
export declare const logout: MaybeContext<BuildRESTFunction<typeof publicLogout> & typeof publicLogout>;
export declare const verify: MaybeContext<BuildRESTFunction<typeof publicVerify> & typeof publicVerify>;
export { PrivacyStatus, EmailTag, PhoneTag, AddressTag, StateType, StatusName, Reason, FactorType, Status, FactorStatus, MfaReason, UserVerificationRequirement, TenantType, } from './iam-authentication-v1-authentication-authentication.universal.js';
export { Authentication, RegisterV2Request, LoginId, LoginIdTypeOneOf, IdentityProfile, CustomField, V1CustomValue, V1CustomValueValueOneOf, V1ListValue, V1MapValue, SecondaryEmail, Phone, AddressWrapper, Address, CaptchaToken, CaptchaTokenTokenOneOf, StateMachineResponse, StateMachineResponseStateDataOneOf, Identity, Connection, ConnectionTypeOneOf, IdpConnection, AuthenticatorConnection, Metadata, Email, StatusV2, Factor, CustomValue, CustomValueValueOneOf, ListValue, MapValue, RequireMfaData, V1Factor, MfaChallengeData, VerificationChallenge, VerificationChallengeFactorChallengeDataOneOf, PushChallengeData, WebAuthnChallengeData, PublicKeyCredentialDescriptor, AuthenticationExtensionInputs, AuthenticationExtensionInputsLargeBlobOperationOneOf, LoginV2Request, ChangePasswordRequest, ChangePasswordResponse, LoginWithIdpConnectionRequest, RawHttpResponse, HeadersEntry, RawHttpRequest, PathParametersEntry, QueryParametersEntry, LoginCallbackRequest, LoginWithIdpConnectionTokenParamsRequest, SignOnRequest, SignOnResponse, LogoutRequest, VerifyRequest, VerifyRequestFactorDataOneOf, SmsVerifyData, CallVerifyData, ExternalEmailVerifyData, TotpVerifyData, PushVerifyData, WebAuthnVerifyData, RegisterV2Options, LoginV2Options, LoginCallbackOptions, SignOnOptions, LogoutOptions, VerifyOptions, VerifyOptionsFactorDataOneOf, } from './iam-authentication-v1-authentication-authentication.universal.js';
